Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.1.6 generated on August 25 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## kodo.meta
Interface JDOMetaDataRepository

All Superinterfaces:
  ImplHelper.RegisterClassListener

All Known Implementing Classes:
  DelegatingJDOMetaDataRepository

public interface JDOMetaDataRepository
extends ImplHelper.RegisterClassListener

Repository of JDO metadata.

Since:
  3.0

Method Summary
`void` | `addMetaData(ClassMetaData meta)` Add a metadata instance to the repository.
`void` | `clear()` Clear the cache of parsed metadata.
`JDOConfiguration` | `getConfiguration()` Return the configuration for the repository.
`ClassMetaData` | `getEmbeddedMetaData(ClassMetaData owner, int field)` Return the class metadata for the embedded value of the given field.
`JDOMetaDataGenerator` | `getGenerator()` Return the generator to use to create default metadata.
`ClassMetaData` | `getMetaData(Class cls, ClassLoader pmLoader, boolean mustExist)` Return the metadata for the given class.
`ClassMetaData` | `getMetaData(Object oid, ClassLoader pmLoader, boolean mustExist)` Return the least-derived class metadata for the given application identity object.
`ClassMetaData[]` | `getMetaDatas()` Return all the metadata instances currently in the repository.
`ClassMetaData[]` | `getMetaDatas(Class cls, boolean impls, ClassLoader pmLoader, boolean mustExist)` Return all metadatas for the given class.
`JDOMetaDataParser` | `getParser()` Return the parser to use to parse jdo metadata files.
`int` | `getValidate()` The metadata validation level.
`boolean` | `getValidateExtensionKeys()` Whether to validate extension keys against the known set.
`boolean` | `hasMetaData(Class cls)` Return true if the repository has metadata for the given class.
`boolean` | `removeMetaData(Class cls)` Remove a metadata instance from the repository.
`boolean` | `removeMetaData(ClassMetaData meta)` Remove a metadata instance from the repository.
`void` | `setGenerator(JDOMetaDataGenerator generator)` Set the generator to use to create default metadata.
`void` | `setParser(JDOMetaDataParser parser)` Set the parser to use to parse jdo metadata files.
`void` | `setValidate(int validate)` The metadata validation level.
`void` | `setValidateExtensionKeys(boolean validate)` Whether to validate extension keys against the known set.

Methods inherited from interface kodo.util.ImplHelper.RegisterClassListener
`registerClass`

Method Detail

### getConfiguration

    public JDOConfiguration getConfiguration()

  Return the configuration for the repository.

### getParser

    public JDOMetaDataParser getParser()

  Return the parser to use to parse jdo metadata files.

### setParser

    public void setParser(JDOMetaDataParser parser)

  Set the parser to use to parse jdo metadata files.

### getGenerator

    public JDOMetaDataGenerator getGenerator()

  Return the generator to use to create default metadata.

### setGenerator

    public void setGenerator(JDOMetaDataGenerator generator)

  Set the generator to use to create default metadata.

### getValidate

    public int getValidate()

  The metadata validation level. One of the constants from `ClassMetaData`.

### setValidate

    public void setValidate(int validate)

  The metadata validation level. One of the constants from `ClassMetaData`.

### getValidateExtensionKeys

    public boolean getValidateExtensionKeys()

  Whether to validate extension keys against the known set. Defaults to true.

### setValidateExtensionKeys

    public void setValidateExtensionKeys(boolean validate)

  Whether to validate extension keys against the known set. Defaults to true.

### getMetaData

    public ClassMetaData getMetaData(Class cls,
                                     ClassLoader pmLoader,
                                     boolean mustExist)

  Return the metadata for the given class.
  Parameters:
    `cls` - the class to retrieve metadata for
    `pmLoader` - the persistence manager's class loader, if any
    `mustExist` - if true, throws a `JDOMetaDataNotFoundException` if no metadata is found

### getEmbeddedMetaData

    public ClassMetaData getEmbeddedMetaData(ClassMetaData owner,
                                             int field)

  Return the class metadata for the embedded value of the given field.

### getMetaDatas

    public ClassMetaData[] getMetaDatas()

  Return all the metadata instances currently in the repository.

### hasMetaData

    public boolean hasMetaData(Class cls)

  Return true if the repository has metadata for the given class.

### addMetaData

    public void addMetaData(ClassMetaData meta)

  Add a metadata instance to the repository.

### removeMetaData

    public boolean removeMetaData(ClassMetaData meta)

  Remove a metadata instance from the repository.
  Returns:
    true if removed, false if not in this repository

### removeMetaData

    public boolean removeMetaData(Class cls)

  Remove a metadata instance from the repository.
  Returns:
    true if removed, false if not in this repository

### getMetaData

    public ClassMetaData getMetaData(Object oid,
                                     ClassLoader pmLoader,
                                     boolean mustExist)

  Return the least-derived class metadata for the given application identity object.
  Parameters:
    `oid` - the oid to get the metadata for
    `pmLoader` - the persistence manager's class loader, if any
    `mustExist` - if true, throws a `JDOMetaDataNotFoundException` if no metadata is found

### getMetaDatas

    public ClassMetaData[] getMetaDatas(Class cls,
                                        boolean impls,
                                        ClassLoader pmLoader,
                                        boolean mustExist)

  Return all metadatas for the given class. If the class is concrete, only the class metadata will be returned. If the class is an interface or is abstract, metadata for all least-derived classes that implement/ extend the class will be returned.
  Parameters:
    `cls` - the class or interface to retrieve metadata for
    `impls` - true to include implementations of the given class if it is non-persistent type, or false to consider the given class only
    `pmLoader` - the persistence manager's class loader, if any
    `mustExist` - if true, throws a `JDOMetaDataNotFoundException` if impls are not included and no metadata is found

### clear

    public void clear()

  Clear the cache of parsed metadata. This method also clears the internal parser's cache of parsed files.

Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.1.6 generated on August 25 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001,2002 SolarMetric, Inc. All Rights Reserved.